Index: code/branches/pickups2/src/orxonox/objects/pickup/Jump.cc
===================================================================
--- code/branches/pickups2/src/orxonox/objects/pickup/Jump.cc	(revision 3039)
+++ code/branches/pickups2/src/orxonox/objects/pickup/Jump.cc	(revision 3040)
Index: code/branches/pickups2/src/orxonox/objects/pickup/PickupCollection.cc
===================================================================
--- code/branches/pickups2/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3039)
+++ code/branches/pickups2/src/orxonox/objects/pickup/PickupCollection.cc	(revision 3040)
@@ -45,4 +45,7 @@
 namespace orxonox
 {
+    typedef std::pair<std::multimap<std::string, BaseItem*>::iterator, std::multimap<std::string, BaseItem*>::iterator> item_range;
+    typedef std::pair<std::multimap<ModifierType::Enum, float>::iterator, std::multimap<ModifierType::Enum, float>::iterator> modifier_range;
+
     //! Constructor
     PickupCollection::PickupCollection()
@@ -55,5 +58,5 @@
         @brief
             Add an item to the collection.
-            
+
             Only adds the item if there's a free slot for it.
 
@@ -122,5 +125,5 @@
         else
         {
-            std::multimap<std::string, BaseItem*>::_Pairii bounds = this->items_.equal_range(item->getPickupIdentifier());
+            item_range bounds = this->items_.equal_range(item->getPickupIdentifier());
             for (std::multimap<std::string, BaseItem*>::iterator it = bounds.first; it != bounds.second && it != this->items_.end(); it++)
             {
@@ -174,5 +177,5 @@
         else
         {
-            std::multimap<std::string, BaseItem*>::_Pairii bounds = this->items_.equal_range(item->getPickupIdentifier());
+            item_range bounds = this->items_.equal_range(item->getPickupIdentifier());
             for (std::multimap<std::string, BaseItem*>::iterator it = bounds.first; it != bounds.second && it != this->items_.end(); it++)
             {
@@ -193,5 +196,5 @@
             else
                 this->currentUsable_ = NULL;
-            
+
         }
     }
@@ -214,5 +217,5 @@
         float v = 0.0f;
 
-        std::multimap<ModifierType::Enum, float>::_Pairii range = this->additiveModifiers_.equal_range(type);
+        modifier_range range = this->additiveModifiers_.equal_range(type);
 
         for (std::multimap<ModifierType::Enum, float>::iterator it = range.first; it != range.second && it != this->additiveModifiers_.end(); it++)
@@ -230,5 +233,5 @@
     void PickupCollection::removeAdditiveModifier(ModifierType::Enum type, float value)
     {
-        std::multimap<ModifierType::Enum, float>::_Pairii range = this->additiveModifiers_.equal_range(type);
+        modifier_range range = this->additiveModifiers_.equal_range(type);
         for (std::multimap<ModifierType::Enum, float>::iterator it = range.first; it != range.second && it != this->additiveModifiers_.end(); it++)
         {
@@ -258,5 +261,5 @@
         float v = 1.0f;
 
-        std::multimap<ModifierType::Enum, float>::_Pairii range = this->multiplicativeModifiers_.equal_range(type);
+        modifier_range range = this->multiplicativeModifiers_.equal_range(type);
         for (std::multimap<ModifierType::Enum, float>::iterator it = range.first; it != range.second && it != this->multiplicativeModifiers_.end(); it++)
         {
@@ -273,5 +276,5 @@
     void PickupCollection::removeMultiplicativeModifier(ModifierType::Enum type, float value)
     {
-        std::multimap<ModifierType::Enum, float>::_Pairii range = this->multiplicativeModifiers_.equal_range(type);
+        modifier_range range = this->multiplicativeModifiers_.equal_range(type);
         for (std::multimap<ModifierType::Enum, float>::iterator it = range.first; it != range.second && it != this->multiplicativeModifiers_.end(); it++)
         {
Index: code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.cc
===================================================================
--- code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3039)
+++ code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.cc	(revision 3040)
Index: code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.h
===================================================================
--- code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.h	(revision 3039)
+++ code/branches/pickups2/src/orxonox/objects/pickup/PickupInventory.h	(revision 3040)