Index: code/branches/netp3/src/network/Client.cc
===================================================================
--- code/branches/netp3/src/network/Client.cc	(revision 3044)
+++ code/branches/netp3/src/network/Client.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/Client.h
===================================================================
--- code/branches/netp3/src/network/Client.h	(revision 3044)
+++ code/branches/netp3/src/network/Client.h	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/ClientConnection.cc
===================================================================
--- code/branches/netp3/src/network/ClientConnection.cc	(revision 3044)
+++ code/branches/netp3/src/network/ClientConnection.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/ClientConnection.h
===================================================================
--- code/branches/netp3/src/network/ClientConnection.h	(revision 3044)
+++ code/branches/netp3/src/network/ClientConnection.h	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/GamestateManager.cc
===================================================================
--- code/branches/netp3/src/network/GamestateManager.cc	(revision 3044)
+++ code/branches/netp3/src/network/GamestateManager.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/GamestateManager.h
===================================================================
--- code/branches/netp3/src/network/GamestateManager.h	(revision 3044)
+++ code/branches/netp3/src/network/GamestateManager.h	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/Server.cc
===================================================================
--- code/branches/netp3/src/network/Server.cc	(revision 3044)
+++ code/branches/netp3/src/network/Server.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/Server.h
===================================================================
--- code/branches/netp3/src/network/Server.h	(revision 3044)
+++ code/branches/netp3/src/network/Server.h	(revision 3045)
@@ -21,21 +21,9 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2007
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
  *
  */
-
-//
-// C++ Interface: Server
-//
-// Description:
-//
-//
-// Author:  Oliver Scheuss, (C) 2007
-//
-// Copyright: See COPYING file that comes with this distribution
-//
-//
 
 #ifndef _Server_H__
Index: code/branches/netp3/src/network/packet/Gamestate.cc
===================================================================
--- code/branches/netp3/src/network/packet/Gamestate.cc	(revision 3044)
+++ code/branches/netp3/src/network/packet/Gamestate.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2008
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/packet/Gamestate.h
===================================================================
--- code/branches/netp3/src/network/packet/Gamestate.h	(revision 3044)
+++ code/branches/netp3/src/network/packet/Gamestate.h	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2008
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/synchronisable/SynchronisableVariable.cc
===================================================================
--- code/branches/netp3/src/network/synchronisable/SynchronisableVariable.cc	(revision 3044)
+++ code/branches/netp3/src/network/synchronisable/SynchronisableVariable.cc	(revision 3045)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Oliver Scheuss, (C) 2008
+ *      Oliver Scheuss
  *   Co-authors:
  *      ...
Index: code/branches/netp3/src/network/synchronisable/SynchronisableVariable.h
===================================================================
--- code/branches/netp3/src/network/synchronisable/SynchronisableVariable.h	(revision 3044)
+++ code/branches/netp3/src/network/synchronisable/SynchronisableVariable.h	(revision 3045)
@@ -81,8 +81,4 @@
       virtual inline void* getReference(){ return (void *)&this->variable_; }
     protected:
-//       inline bool checkEquality(uint8_t* mem);
-//       inline void loadAndIncrease(uint8_t*& mem);
-//       inline void saveAndIncrease(uint8_t*& mem);
-//       inline uint32_t returnSize();
       
       T& variable_;
@@ -133,5 +129,4 @@
     else
       return 0;
-//   mem += SynchronisableVariable<T>::getSize();
   }
 
@@ -192,5 +187,4 @@
   // now write the content
       saveAndIncrease( this->variable_, mem );
-//   mem += SynchronisableVariable<T>::getSize();
       return SynchronisableVariableBidirectional::getSize(mode);
     }
@@ -204,4 +198,5 @@
         if ( *static_cast<uint8_t*>(mem) != this->varReference_ )
         { // wrong reference number, so discard the data
+//           COUT(0) << "discharding data" << endl;
           mem += getSize( mode ); // SynchronisableVariableBidirectional::getSize returns size of variable + reference
           return;
@@ -247,5 +242,4 @@
       if ( callback )
         NetworkCallbackManager::triggerCallback( this->callback_ );
-        //this->callback_->call();
     }
 
@@ -258,5 +252,4 @@
 }
 
-//#include "network/synchronisable/SynchronisableVariableSpecialisations.h"
 
 #endif